Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/BiosFile.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/BiosFile.asm	(revision 290)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/BiosFile.asm	(revision 293)
@@ -27,5 +27,5 @@
 	call	Buffers_NewBiosWithSizeInDXCXandSourceInAXhasBeenLoadedForConfiguration
 	call	FileIO_CloseUsingHandleFromBX
-	call	DisplayFileLoadedSuccesfully
+	call	DisplayFileLoadedSuccessfully
 	jmp		SHORT .Return
 
@@ -43,7 +43,7 @@
 ;		DS:SI:	Name of file to open
 ;	Returns:
-;		BX:		File handle (if succesfull)
-;		DX:CX:	File size (if succesfull)
-;		CF:		Clear if successfull
+;		BX:		File handle (if successful)
+;		DX:CX:	File size (if successful)
+;		CF:		Clear if successful
 ;				Set if error
 ;	Corrupts registers:
@@ -80,5 +80,5 @@
 ;		DS:SI:	File name
 ;	Returns:
-;		CF:		Clear if successfull
+;		CF:		Clear if successful
 ;				Set if error
 ;	Corrupts registers:
@@ -167,5 +167,5 @@
 	call	FileIO_CloseUsingHandleFromBX
 	call	Buffers_ClearUnsavedChanges
-	call	DisplayFileSavedSuccesfully
+	call	DisplayFileSavedSuccessfully
 	jmp		SHORT .Return
 
@@ -181,6 +181,6 @@
 
 ;--------------------------------------------------------------------
-; DisplayFileLoadedSuccesfully
-; DisplayFileSavedSuccesfully
+; DisplayFileLoadedSuccessfully
+; DisplayFileSavedSuccessfully
 ; DisplayFailedToLoadFile
 ; DisplayFailedToSaveFile
@@ -194,10 +194,10 @@
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
-DisplayFileLoadedSuccesfully:
+DisplayFileLoadedSuccessfully:
 	mov		dx, g_szDlgMainLoadFile
 	jmp		Dialogs_DisplayNotificationFromCSDX
 
 ALIGN JUMP_ALIGN
-DisplayFileSavedSuccesfully:
+DisplayFileSavedSuccessfully:
 	mov		dx, g_szDlgMainSaveFile
 	jmp		Dialogs_DisplayNotificationFromCSDX
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Buffers.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Buffers.asm	(revision 290)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Buffers.asm	(revision 293)
@@ -145,5 +145,5 @@
 	push	es
 
-	eMOVZX	di, BYTE [cs:g_cfgVars+CFGVARS.bEepromType]
+	eMOVZX	di, [cs:g_cfgVars+CFGVARS.bEepromType]
 	mov		cx, [cs:di+g_rgwEepromTypeToSizeInWords]
 	sub		cx, [cs:g_cfgVars+CFGVARS.wImageSizeInWords]	; CX = WORDs to append
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/EEPROM.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/EEPROM.asm	(revision 290)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/EEPROM.asm	(revision 293)
@@ -91,5 +91,5 @@
 .GetXtideUniversalBiosSizeFromEStoDXCX:
 	xor		dx, dx
-	eMOVZX	cx, BYTE [es:ROMVARS.bRomSize]
+	eMOVZX	cx, [es:ROMVARS.bRomSize]
 	eSHL_IM	cx, 9				; *= 512 for byte count
 	ret
@@ -199,5 +199,5 @@
 	xor		si, si
 	call	Buffers_GetFlashComparisonBufferToESDI
-	eMOVZX	bx, BYTE [cs:g_cfgVars+CFGVARS.bEepromType]
+	eMOVZX	bx, [cs:g_cfgVars+CFGVARS.bEepromType]
 	mov		cx, [cs:bx+g_rgwEepromTypeToSizeInWords]
 	cld
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Flash.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Flash.asm	(revision 290)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Flash.asm	(revision 293)
@@ -86,5 +86,5 @@
 ALIGN JUMP_ALIGN
 .GetSdpCommandFunctionToDXwithFlashvarsInSSBP:
-	eMOVZX	bx, BYTE [bp+FLASHVARS.bEepromSdpCommand]
+	eMOVZX	bx, [bp+FLASHVARS.bEepromSdpCommand]
 	mov		si, [cs:bx+.rgpSdpCommandToEepromTypeLookupTable]
 	mov		bl, [bp+FLASHVARS.bEepromType]
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menuitem.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menuitem.asm	(revision 290)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menuitem.asm	(revision 293)
@@ -146,5 +146,5 @@
 ALIGN JUMP_ALIGN
 Menuitem_StoreValueFromAXtoMenuitemInDSSI:
-	eMOVZX	bx, BYTE [si+MENUITEM.bType]
+	eMOVZX	bx, [si+MENUITEM.bType]
 	cmp		bl, TYPE_MENUITEM_HEX
 	ja		SHORT .InvalidItemType
@@ -207,9 +207,9 @@
 ;
 ; if the lookup pointer is NULL, no translation is needed
-; 
+;
 	mov		bx, [si+MENUITEM.itemValue+ITEM_VALUE.rgwChoiceToValueLookup]
 	test	bx, bx
 	jz		.StoreByteOrWordValueFromAXtoESDIwithItemInDSSI
-		
+
 	shl		ax, 1			; Shift for WORD lookup
 	add		bx, ax
@@ -234,7 +234,7 @@
 	mov		bx,[si+MENUITEM.itemValue+ITEM_VALUE.fnValueWriter]
 	test	bx,bx
-	jz		SHORT .NoWriter	
-
-	call	bx		
+	jz		SHORT .NoWriter
+
+	call	bx
 
 .NoWriter:
@@ -313,5 +313,5 @@
 	xor		ah, ah				; conversion needs to happen before call to the reader,
 								; in case the reader unpacks the byte to a word
-		
+
 .NoConvertWordToByteValue:
 	mov		bx, [si+MENUITEM.itemValue+ITEM_VALUE.fnValueReader]
@@ -321,5 +321,5 @@
 	call	bx
 
-.NoReader:		
+.NoReader:
 	pop		bx
 	pop		di
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/MenuitemPrint.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/MenuitemPrint.asm	(revision 290)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/MenuitemPrint.asm	(revision 293)
@@ -36,5 +36,5 @@
 ALIGN JUMP_ALIGN
 MenuitemPrint_NameWithPossibleValueFromDSSI:
-	eMOVZX	bx, BYTE [si+MENUITEM.bType]
+	eMOVZX	bx, [si+MENUITEM.bType]
 	cmp		bl, TYPE_MENUITEM_ACTION
 	ja		SHORT .PrintNameAndValueFromDSSI
@@ -147,5 +147,5 @@
 ;	Corrupts registers:
 ;		AX, BX, CX
-;--------------------------------------------------------------------	
+;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
 MenuitemPrint_WriteLookupValueStringToBufferInESDIfromUnshiftedItemInDSSI:
@@ -170,14 +170,14 @@
 ;	Corrupts registers:
 ;		AX, BX, CX
-;--------------------------------------------------------------------	
+;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
 PrintLookupValueFromAXtoBufferInESDI:
 	push	si
 	test	byte [si+MENUITEM.bFlags], FLG_MENUITEM_CHOICESTRINGS
-	jnz		.lookupChoice	
-		
+	jnz		.lookupChoice
+
 	add		ax, [si+MENUITEM.itemValue+ITEM_VALUE.rgszValueToStringLookup]
 	xchg	bx, ax
-.found:	
+.found:
 	mov		si, [bx]
 .errorReturn:
@@ -187,9 +187,9 @@
 
 ;
-; With FLG_MENUITEM_CHOICESTRINGS, the array at .rgszChoiceToStringLookup is based on the 
+; With FLG_MENUITEM_CHOICESTRINGS, the array at .rgszChoiceToStringLookup is based on the
 ; Choice number (offset within .rgwChoiceToValueLookup) instead of the value stored.
 ; Here, we scan the .rgwChoiceToValueLookup array until we find the value there, and then
-; use the same offset in .rgszChoiceToStringLookup.  If we don't find the value, we 
-; return an "Error!" string instead.  
+; use the same offset in .rgszChoiceToStringLookup.  If we don't find the value, we
+; return an "Error!" string instead.
 ;
 ; Note that the pointer array at .rgszChoiceToStringLookup must be NULL terminated.  Since the
@@ -197,7 +197,7 @@
 ;
 .lookupChoice:
-	mov		bx,[si+MENUITEM.itemValue+ITEM_VALUE.rgszChoiceToStringLookup]		
+	mov		bx,[si+MENUITEM.itemValue+ITEM_VALUE.rgszChoiceToStringLookup]
 	mov		si,[si+MENUITEM.itemValue+ITEM_VALUE.rgwChoiceToValueLookup]
-		
+
 .wordLoop:
 	cmp		ax,[si]
@@ -222,5 +222,5 @@
 ;	Corrupts registers:
 ;		AX, BX, CX
-;--------------------------------------------------------------------	
+;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
 MenuitemPrint_WriteUnsignedValueStringToBufferInESDIfromItemInDSSI:
@@ -244,5 +244,5 @@
 ;	Corrupts registers:
 ;		AX, BX, CX
-;--------------------------------------------------------------------	
+;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
 MenuitemPrint_WriteHexValueStringToBufferInESDIfromItemInDSSI:
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/FlashMenu.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/FlashMenu.asm	(revision 290)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/FlashMenu.asm	(revision 293)
@@ -273,5 +273,5 @@
 	mov		[si+FLASHVARS.bEepromSdpCommand], al
 
-	eMOVZX	bx, BYTE [cs:g_cfgVars+CFGVARS.bEepromPage]
+	eMOVZX	bx, [cs:g_cfgVars+CFGVARS.bEepromPage]
 	mov		ax, [cs:bx+g_rgwEepromPageToSizeInBytes]
 	mov		[si+FLASHVARS.wEepromPageSize], ax
@@ -314,5 +314,5 @@
 ALIGN JUMP_ALIGN
 .GetSelectedEepromSizeInWordsToAX:
-	eMOVZX	bx, BYTE [cs:g_cfgVars+CFGVARS.bEepromType]
+	eMOVZX	bx, [cs:g_cfgVars+CFGVARS.bEepromType]
 	mov		ax, [cs:bx+g_rgwEepromTypeToSizeInWords]
 	ret
@@ -330,5 +330,5 @@
 ALIGN JUMP_ALIGN
 .DisplayFlashingResultsFromFlashvarsInDSBX:
-	eMOVZX	bx, BYTE [bx+FLASHVARS.flashResult]
+	eMOVZX	bx, [bx+FLASHVARS.flashResult]
 	jmp		[cs:bx+.rgfnFlashResultMessage]
 
@@ -370,5 +370,5 @@
 ALIGN JUMP_ALIGN
 .DisplayRebootMessageAndReboot:
-	mov		dx, g_szPCFlashSuccessfull
+	mov		dx, g_szPCFlashSuccessful
 	call	Dialogs_DisplayNotificationFromCSDX
 	xor		ax, ax			; Cold boot flag
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/MasterSlaveMenu.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/MasterSlaveMenu.asm	(revision 290)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/MasterSlaveMenu.asm	(revision 293)
@@ -238,5 +238,5 @@
 	call	.EnableMenuitemFromCSBX
 	mov		bx, g_MenuitemMasterSlaveUserLBA
-	jmp		.EnableMenuitemFromCSBX	
+	jmp		.EnableMenuitemFromCSBX
 
 ALIGN JUMP_ALIGN
@@ -245,5 +245,5 @@
 	call	.EnableMenuitemFromCSBX
 	mov		bx, g_MenuitemMasterSlaveUserLBA
-	jmp		.DisableMenuitemFromCSBX	
+	jmp		.DisableMenuitemFromCSBX
 
 ALIGN JUMP_ALIGN
@@ -252,5 +252,5 @@
 	call	.EnableMenuitemFromCSBX
 	mov		bx, g_MenuitemMasterSlaveUserCHS
-	jmp		.DisableMenuitemFromCSBX	
+	jmp		.DisableMenuitemFromCSBX
 
 
@@ -308,5 +308,5 @@
 	test	ax, FLG_DRVPARAMS_USERLBA
 	jz		SHORT .DisableMenuitemFromCSBX
-	jmp		SHORT .EnableMenuitemFromCSBX
+	; Fall to .EnableMenuitemFromCSBX
 
 
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm	(revision 290)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm	(revision 293)
@@ -22,8 +22,7 @@
 
 g_szNo:								db	"No",NULL
-g_szYes:							db	"Yes",NULL
 g_szMultichoiceBooleanFlag:
 									db	"No",LF
-									db	"Yes",NULL
+g_szYes:							db	"Yes",NULL
 
 ; Exit messages
@@ -44,5 +43,5 @@
 g_szErrEepromVerify:	db	"EEPROM did not return the same byte that was written.",LF
 						db	"EEPROM was not flashed properly!",NULL
-g_szPCFlashSuccessfull:	db	"EEPROM was written successfully.",LF
+g_szPCFlashSuccessful:	db	"EEPROM was written successfully.",LF
 						db	"Press any key to reboot.",NULL
 g_szForeignFlash:		db	"EEPROM was written successfully.",NULL
@@ -374,8 +373,7 @@
 						db	"None",LF
 						db	"Enable",LF
-						db	"Disable",NULL
+g_szValueFlashDisable:	db	"Disable",NULL
 g_szValueFlashNone:		db	"None",NULL
 g_szValueFlashEnable:	db	"Enable",NULL
-g_szValueFlashDisable:	db	"Disable",NULL
 
 g_szMultichoicePageSize:
@@ -386,5 +384,5 @@
 						db	"16 bytes",LF
 						db	"32 bytes",LF
-						db	"64 bytes",NULL
+g_szValueFlash64bytes:	db	"64 bytes",NULL
 g_szValueFlash1byte:	db	"1 byte",NULL
 g_szValueFlash2bytes:	db	"2 bytes",NULL
@@ -393,5 +391,4 @@
 g_szValueFlash16bytes:	db	"16 bytes",NULL
 g_szValueFlash32bytes:	db	"32 bytes",NULL
-g_szValueFlash64bytes:	db	"64 bytes",NULL
 
 g_szSelectionTimeout:	db		DOUBLE_BOTTOM_LEFT_CORNER,DOUBLE_LEFT_HORIZONTAL_TO_SINGLE_VERTICAL,"%ASelection in %2u s",NULL
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/makefile
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/makefile	(revision 290)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/makefile	(revision 293)
@@ -1,11 +1,7 @@
 ###############################################################################
-# Generic makefile for building binary files.                                 #
-# v. 1.1.0 (28.7.2007 ... 5.10.2010)                                          #
-# (C) Tomi Tilli                                                              #
-# aitotat@gmail.com                                                           #
+# Makefile to build XTIDE Universal BIOS Configurator v2.                     #
 #                                                                             #
 # Valid makefile targets are:                                                 #
 # all		Removes existing files and builds binary file in \Build           #
-# build		Builds binary file in \Build                                      #
 # clean		Removes all files from \Build                                     #
 #                                                                             #
@@ -54,5 +50,4 @@
 
 
-
 #################################################################
 # Assembler preprocessor defines.                               #
@@ -61,5 +56,5 @@
 DEFINES_XT = ELIMINATE_CGA_SNOW
 DEFINES_XTPLUS = USE_186 ELIMINATE_CGA_SNOW
-DEFINES_AT = USE_186 USE_286 USE_AT
+DEFINES_AT = USE_286 USE_AT
 
 
@@ -113,5 +108,4 @@
 .PHONY: all at xtplus xt clean release
 
-# Make clean debug and release versions
 all: clean xt
 	@echo All done!
@@ -123,5 +117,5 @@
 xtplus:
 	@$(AS) "$(SRC_ASM)" $(ASFLAGS) $(DEFS_XTPLUS) -l"$(TARGET)_xtp.lst" -o"$(TARGET)_xtp.$(EXTENSION)"
-	@echo XT plus version "$(TARGET)_xtp.$(EXTENSION)" built.
+	@echo XT Plus version "$(TARGET)_xtp.$(EXTENSION)" built.
 
 xt: