Index: wiki/SerialDrives.wiki
===================================================================
--- wiki/SerialDrives.wiki	(revision 308)
+++ wiki/SerialDrives.wiki	(revision 309)
@@ -25,12 +25,12 @@
 == Getting Started ==
 
-# * Connect the two machines via the serial connection. *
+1. * Connect the two machines via the serial connection. *
 
-# * Open a command prompt, and run the SerDrive utility on the server. *  Arguments are described below.  In its simplest form:
+2. * Open a command prompt, and run the SerDrive utility on the server. *  Arguments are described below.  In its simplest form:
 	C:/> SerDrive MyImage.img
 If you do not already have an image, you can obtain boot floppies of FreeDOS from.
 SerDrive will use the first available COM port by default, at a speed of 9600 baud (which is reliable, but relatively slow, you will likely want to increase this for continued use).
 
-# * Boot the client computer.  During drive detection, hold down the Alt key, and at the end of drive detection, the BIOS will display "Serial Master on COM Detect". *  The BIOS will now scan the available COM ports on the client (COM 1-7), looking for a server.
+3. * Boot the client computer.  During drive detection, hold down the Alt key, and at the end of drive detection, the BIOS will display "Serial Master on COM Detect". *  The BIOS will now scan the available COM ports on the client (COM 1-7), looking for a server.
 
 If a server is found, the floppy and/or hard disk emulated will appear in the boot menu for the BIOS.  You can now proceed as normal.
@@ -50,21 +50,21 @@
 * Usage: SerDrive [options] imagefile [[slave-options] slave-imagefile] *
 
-* -g [cyl:head:sect] *
+Specify Disk Geometry: * -g [cyl:head:sect] *
 
 Geometry in cylinders, sectors per cylinder, and heads.  -g also implies CHS addressing mode (default is LBA28).
 
-* -n [megabytes] *
+Create New Disk Image: * -n [megabytes] *
 
 Create new disk with given size or use -g geometry.  Maximum size is 137438 MB (the LBA28 size limit).  Floppy images can also be created, such as "360K".  Default disk size is 32 MB disk, with a CHS geometry 65:16:63.
 
-* -p [pipename] *
+Emulator Pipe Mode: * -p [pipename] *
 
 Named Pipe mode for emulators.  Pipe name must begin with "\\", default is "\\.\pipe\xtide".
 
-*-c COMPortNumber *
+Specify COM Port: *-c COMPortNumber *
 
 COM Port to use (default is first found).  The usage message will also list the available COM ports on this system.
 
-* -b BaudRate *
+Specify Baud Rate: * -b BaudRate *
 
 Baud rate to use on the COM port.  If the client machine has a hardware rate multipler (for high speed operation), then that will impact this setting:
@@ -77,17 +77,17 @@
 And for completeness, 76.8K and 153.6K can also be set.  The default baud rate is 9600 (115.2K when used in named pipe mode)
 
-* -t * 
+Disable Operation Timeout: * -t * 
 
 Disable timeout, useful for long delays when debugging.
 
-* -r *
+Read Only Disk: * -r *
 
 Treat the disk as a Read Only disk, SerDrive will not allow writes.
 
-* -v [level] *
+Verbose: * -v [level] *
 
 Reporting level 1-6, with increasing information as the number increases.  This switch can be very useful for seeing the secot-by-secotr traffic between the PC and the hard disk.
 
-* ImageFile *
+ImageFiles: * ImageFileName *
 
 Finally, the image file name appears. Up to two image files can be used, each with their own settings for many of the switches above.
@@ -104,9 +104,9 @@
 The BIOS supports speeds up to 460.8K baud.  To achieve this speed, you will need:
 
-* COM port on the client machine capable of high speed operation.  Believe it or not, one can still buy new ISA High Speed COM ports that accomplish this, that can even be used in old 8-bit machines.  Serial cards that have been tested:
+  * COM port on the client machine capable of high speed operation.  Believe it or not, one can still buy new ISA High Speed COM ports that accomplish this, that can even be used in old 8-bit machines.  Serial cards that have been tested:
 
- In addition, the XTIDE mk II has a high speed COM port installed for this purpose.
+ In addition, the [http://www.vintage-computer.com/vcforum/showwiki.php?title=XTIDE+Rev2 XTIDE rev2] has a high speed COM port installed for this purpose.
 
-* COM port on the server machine capable of high speed operation.  Most motherboard based COM ports can NOT attain high speed.  However, most USB COM ports can attain high speed.  USB serial ports that have been tested:
+  * COM port on the server machine capable of high speed operation.  Most motherboard based COM ports can NOT attain high speed.  However, most USB COM ports can attain high speed.  USB serial ports that have been tested:
 
 Care must be taken when configuring the serial connection - the clock multiplier is not detectable by the client PC.  With a 4x clock multiplier, the client PC should be set to 115.2K baud, while the matching server needs to be set to 460.8K baud.