Index: trunk/Assembly_Library/Inc/Display.inc
===================================================================
--- trunk/Assembly_Library/Inc/Display.inc	(revision 336)
+++ trunk/Assembly_Library/Inc/Display.inc	(revision 341)
@@ -64,5 +64,5 @@
 %endif
 	.PrintWordFromAXwithBaseInBX					resb	2
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS OR EXCLUDE_FROM_XTIDECFG
 	.PrintQWordFromSSBPwithBaseInBX					resb	2
 %endif
Index: trunk/Assembly_Library/Src/Display/Display.asm
===================================================================
--- trunk/Assembly_Library/Src/Display/Display.asm	(revision 336)
+++ trunk/Assembly_Library/Src/Display/Display.asm	(revision 341)
@@ -82,5 +82,5 @@
 %endif
 	%define PrintWordFromAXwithBaseInBX						DisplayPrint_WordFromAXWithBaseInBX
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS OR EXCLUDE_FROM_XTIDECFG
 	%define PrintQWordFromSSBPwithBaseInBX					DisplayPrint_QWordFromSSBPwithBaseInBX
 %endif
Index: trunk/Assembly_Library/Src/Display/DisplayFormat.asm
===================================================================
--- trunk/Assembly_Library/Src/Display/DisplayFormat.asm	(revision 336)
+++ trunk/Assembly_Library/Src/Display/DisplayFormat.asm	(revision 341)
@@ -348,5 +348,5 @@
 	push	cx
 	mov		si, [bp]
-		
+
 	cmp		si, byte 07fh		;  well within the boundaries of ROMVARS_size
 	jb		.notFormatted
@@ -358,20 +358,20 @@
 	inc		bp
 	jmp		.done
-		
-.notFormatted:	
+
+.notFormatted:
 	call	DisplayPrint_NullTerminatedStringFromCSSI
-		
+
 .done:
 	pop		cx
 	pop		si
-	ret		
-
-ALIGN JUMP_ALIGN
-z_FormatStringFromSegmentZero:	
+	ret
+
+ALIGN JUMP_ALIGN
+z_FormatStringFromSegmentZero:
 	xchg	si, [bp]
 	xor		bx, bx
 	call	DisplayPrint_NullTerminatedStringFromBXSI
 	mov		si, [bp]
-	ret		
+	ret
 
 %ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
Index: trunk/Assembly_Library/Src/Display/DisplayPrint.asm
===================================================================
--- trunk/Assembly_Library/Src/Display/DisplayPrint.asm	(revision 336)
+++ trunk/Assembly_Library/Src/Display/DisplayPrint.asm	(revision 341)
@@ -95,4 +95,46 @@
 %ifndef MODULE_STRINGS_COMPRESSED
 ;--------------------------------------------------------------------
+; DisplayPrint_WordFromAXWithBaseInBX
+;	Parameters:
+;		AX:		Word to display
+;		BX:		Integer base (binary=2, octal=8, decimal=10, hexadecimal=16)
+;		DS:		BDA segment (zero)
+;		ES:DI:	Ptr to cursor location in video RAM
+;	Returns:
+;		DI:		Updated offset to video RAM
+;	Corrupts registers:
+;		AX, DX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+DisplayPrint_WordFromAXWithBaseInBX:
+	push	cx
+	push	bx
+
+	xor		cx, cx
+ALIGN JUMP_ALIGN
+.DivideLoop:
+	xor		dx, dx				; DX:AX now holds the integer
+	div		bx					; Divide DX:AX by base
+	push	dx					; Push remainder
+	inc		cx					; Increment character count
+	test	ax, ax				; All divided?
+	jnz		SHORT .DivideLoop	;  If not, loop
+
+PrintAllPushedDigits:
+	mov		bx, g_rgcDigitToCharacter
+ALIGN JUMP_ALIGN
+.PrintNextDigit:
+	pop		ax					; Pop digit
+	cs xlatb
+	call	DisplayPrint_CharacterFromAL
+	loop	.PrintNextDigit
+
+	pop		bx
+	pop		cx
+	ret
+
+g_rgcDigitToCharacter:	db	"0123456789ABCDEF"
+
+;--------------------------------------------------------------------
 ; DisplayPrint_QWordFromSSBPwithBaseInBX
 ;	Parameters:
@@ -106,4 +148,5 @@
 ;		AX, DX, [SS:BP]
 ;--------------------------------------------------------------------
+%ifndef EXCLUDE_FROM_XTIDECFG	; Not used in XTIDECFG
 ALIGN JUMP_ALIGN
 DisplayPrint_QWordFromSSBPwithBaseInBX:
@@ -122,46 +165,5 @@
 	mov		cx, bx				; Character count to CX
 	jmp		SHORT PrintAllPushedDigits
-
-
-;--------------------------------------------------------------------
-; DisplayPrint_WordFromAXWithBaseInBX
-;	Parameters:
-;		AX:		Word to display
-;		BX:		Integer base (binary=2, octal=8, decimal=10, hexadecimal=16)
-;		DS:		BDA segment (zero)
-;		ES:DI:	Ptr to cursor location in video RAM
-;	Returns:
-;		DI:		Updated offset to video RAM
-;	Corrupts registers:
-;		AX, DX
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-DisplayPrint_WordFromAXWithBaseInBX:
-	push	cx
-	push	bx
-
-	xor		cx, cx
-ALIGN JUMP_ALIGN
-.DivideLoop:
-	xor		dx, dx				; DX:AX now holds the integer
-	div		bx					; Divide DX:AX by base
-	push	dx					; Push remainder
-	inc		cx					; Increment character count
-	test	ax, ax				; All divided?
-	jnz		SHORT .DivideLoop	;  If not, loop
-
-PrintAllPushedDigits:
-	mov		bx, g_rgcDigitToCharacter
-ALIGN JUMP_ALIGN
-.PrintNextDigit:
-	pop		ax					; Pop digit
-	cs xlatb
-	call	DisplayPrint_CharacterFromAL
-	loop	.PrintNextDigit
-
-	pop		bx
-	pop		cx
-	ret
-g_rgcDigitToCharacter:	db	"0123456789ABCDEF"
+%endif	; EXCLUDE_FROM_XTIDECFG
 
 %endif	; MODULE_STRINGS_COMPRESSED
Index: trunk/Assembly_Library/Src/Util/Math.asm
===================================================================
--- trunk/Assembly_Library/Src/Util/Math.asm	(revision 336)
+++ trunk/Assembly_Library/Src/Util/Math.asm	(revision 341)
@@ -17,4 +17,5 @@
 ;		AX
 ;--------------------------------------------------------------------
+%ifndef EXCLUDE_FROM_XTIDECFG	; Not used in XTIDECFG
 ALIGN JUMP_ALIGN
 Math_DivQWatSSBPbyCX:
@@ -36,4 +37,5 @@
 	mov		[bp], ax
 	ret
+%endif
 
 